Name
        dapple - an Apple ][, ][+ and //e emulator

Synopsis
        dapple [/q]  [/nospeaker]  [/nohd]  [/rom _filename_]  [/color]
               [/mono]   [/amber]   [/d1 _filename_]   [/d2 _filename_]
               [/h1 _filename_]      [/h2 _filename_]      [/nosaveini]
               [/nocapslock]

Description
        Dapple is an emulator which has basic emulation for an Apple ][
        computer with 48K or 64K RAM (or an  Apple //e with  128K), two
        5.25" floppy drives, two optional  32MB hard drives, and a 3.5"
        high-density  (1.40 MB)  floppy  drive.  The  disk  drives  are
        simulated, through  files  on  the  user's hard disk, with  the
        exception of the 3.5" drive, which  is simulated  on an  actual
        3.5" drive  installed  as  drive A: on  the  user's  system.  A
        joystick  is  also  emulated, using  a  joystick  or  game  pad
        connected to the PC game  port.  This  manual  reflects  Dapple
        version 1.25.

        Options
                /q      Quick load; bypass the startup screen.

                /nospeaker
                        Disables the  speaker on startup.  This setting
                        is  sticky (see /nosaveini  below), but  can be
                        reset in the UI.

                /nohd   Disables the hard disk emulation.  This setting
                        is  sticky (see /nosaveini  below), but  can be
                        reset in the UI.

                /rom _filename_
                        Instructs Dapple to  first search for  the file
                        _filename_ before performing its ROM search. If
                        you wish  to use a  ROM set that  Dapple is not
                        set up  to handle  by default (for example, the
                        ROM sets used by ApplePC), you should  use this
                        the first time you run  Dapple, to allow Dapple
                        to "take" the alternate  ROM set.  This setting
                        is  sticky (see /nosaveini  below), but  can be
                        reset in the UI.

                /d1 _filename_, /d2 _filename_
                        Sets the initial disk images to place in drives
                        1 and 2.  The default is "disk6a.dsk" for drive
                        1 and "disk6b.dsk" for drive 2, a holdover from
                        the _apl2em_ emulator.

                /h1 _filename_, /h2 _filename_
                        Installs  _filename_  as  hard disk 1 or 2, and
                        enables emulation of the  hard disk.  Emulation
                        of the hard disk is sticky, so you may  wish to
                        name  the  hard disk  image  you  use  most  as
                        "hdv1.hdv" for  drive 1 or "hdv2.hdv" for drive
                        2.  When the  hard  disk emulation  is enabled,
                        Dapple will boot  from  the  hard  disk (slot 7
                        drive 1) instead of from the floppy disk.

                /nosaveini
                        Forces all changes to settings  to be discarded
                        on exit. This is useful if one needs to disable
                        the hard disk or the speaker, but does not wish
                        the new settings to "stick".

                /mono, /color, /amber
                        Selects the  console  display method.  This can
                        also be  changed  in  the  user interface or at
                        runtime.

                /nocapslock
                        Disables  tweaking  of  the CAPS LOCK key  when
                        starting and exiting.  This  setting is sticky,
                        but can be reset in the UI.

        Dapple is a functional, but not perfect emulator, but there are
        programs that run better on Dapple  than on some other freeware
        emulators.

        Dapple's  joystick  emulation  does  not  offer  an  option  to
        calibrate the joystick.  Instead, it  automatically  calibrates
        the joystick as it is used. For example, at the Applesoft BASIC
        prompt ("]"), enter the following:

                ]10 ? PDL(0),PDL(1):GOTO 10
                ]RUN

        You will see a series of numbers.  As you hold  the joystick in
        each direction, the  numbers will  approach 0 or 255.  When you
        release the joystick, the numbers will remain around 127.  When
        the numbers remain around 127, the joystick has been calibrated
        and will remain calibrated until you exit the emulator.

        Dapple does not come with ROM images; methods exist for dumping
        the ROM from  a real Apple  and using "adt" to transfer it to a
        PC.  You should name the ROM images according to which Apple ][
        series computer they represent:

                apple.rom       Apple ][+
                apple2m.rom     Apple ][, Monitor ROM
                apple2o.rom     Apple ][, Autostart ROM ("INTBASIC")
                apple2eo.rom    Apple //e, original version ("][")
                apple2ee.rom    Apple //e, enhanced version ("//e")

        If you use the ApplePC emulator, you can use ROM files for that
        emulator by copying them to the appropriate filenames, or using
        the /ROM switch.  Dapple, however, uses a  different native ROM
        format and it  is preferred  to use  12K (for ][ or ][+) or 16K
        (for //e) ROM images over the 20K and 32K files used by ApplePC
        and other emulators.  Proper file sizes are 12,288 or 16,128.

        Dapple  does  support  the  Apple //e  with 128K; however, many
        //e-specific programs that use  the 80-column card will display
        a "scrunched" and barely readable  screen with Dapple (although
        Dapple does handle double resolution graphics quite well).  The
        double-resolution graphics are also a little blurry, since they
        are emulated in a lower resolution.

        More specifically, the  emulation of Dapple is superior in some
        respects to the real machine because:

         * Dapple emulates a keyboard with full uppercase and lowercase
           characters on all models including the Apple ][ and ][+. Not
           all programs can  recognize this; by default  the Apple BIOS
           does not  handle this.  (Reading the  keyboard directly will
           work, however)  If  you  have  the Appler ROM, strip off the
           first four  bytes; the  resulting  ROM  is  compatible  with
           Dapple and supports lowercase in the BIOS.

         * Dapple  features all  lowercase  modifications  known to the
           author.  (Admittedly, the author  has  only  used ][+ models
           that lacked the modifications.  However, FrEdWriter works.)

         * Dapple emulates  two 32MB hard disks - a  feature rarely  if
           ever seen  on real Apple ][ computers.  (ApplePC also offers
           this feature, as does the shareware Apple Oasis)

         * Dapple can read and  write 1.40 MB floppy disks.  The author
           knows of no PC emulators that  can read 3.5" disks, although
           he  has used  an Apple IIgs emulator  on the Macintosh which
           offered  this  functionality.  Very  few  Apple ][ computers
           (the  Mark  ][  prototype  being  an  exception) had 1.40 MB
           drives, but those  that  do  can  be  used to  transfer disk
           images easily to PCs by transferring files within Dapple, or
           using a file transfer  utility combined  with getdisk (which
           comes with Dapple).  It is impossible, however, to read 800K
           Apple disks on a PC, since the coding  of  the  Apple  disks
           (GCR) cannot be  read  by  the PC's (MFM) hardware.  This is
           the same  reason that 140K (5.25") diskettes  cannot be read
           on a PC.

        However, in many respects there are  other  superior emulators,
        more or less for the following reasons:

         * Dapple's screen resolution is 320x200.  This is not enough
           for a clear double-resolution mode, including 80x24 text.

         * Dapple seems not to like some programs.

         * Dapple doesn't do Z80.  Earlier versions attempted this, but
           it never worked  right, and the  Dapple Z80 has finally been
           euthanized.

         * Dapple has succumbed to creeping featuritis.

        For an example of  the last, if you have  an Epson FX/RX clone,
        press F8 to print the screen.  (It's very simple, and not meant
        to replace GRAPHICS.COM, but if you don't have GRAPHICS.COM you
        can use this instead.)  This feature  is disabled by default in
        versions 1.11 and  later, but can be  restored in  the UI under
        "Keyboard Options".

        Dapple features a simple debugger, which can be activated using
        the F9 key.  More powerful features are included in Apple's own
        debugger,  which  is  activated  when  a  BRK ($00)  opcode  is
        encountered; however, Apple's monitor does not have support for
        the 65C02 opcodes.  Dapple's disassembler code has been written
        with the 65C02 opcodes this time around (the original debugger,
        defunct since version 0.88, did not support them either, and it
        didn't  work properly  to begin with).  Future versions  may be
        able to toggle between the different  versions of the 6502 CPU.
        Commands for the debugger resemble a cross between the Apple ][
        disassembler, DEBUG  and  Marat Fayzullin's  built-in  debugger
        (the last being the basis for the initial implementation).

        If you  prefer a monochrome  display, F3 toggles between  color
        and  three types  of monochrome mode.  The monochrome  settings
        do not affect  lo-res mode and have  retro-looking white, green
        or amber color.  Additionally, there  are  five different color
        palettes: an approximation of  that used by the Apple IIgs; the
        RGB palette as reported by  Robert Munafo; an approximation  of
        the palette used by ApplePC; the palette  used by MESS; and the
        "EGA default" palette used  in  earlier (0.05-0.67) versions of
        Dapple.

        As in ApplePC, you may  press Ctrl-Break to  reset the emulated
        CPU.

Known bugs
        There is  only minimal support   for the Apple //e's  80-column
        card: the firmware support is present only when using the newer
        (Enhanced/Platinum) ROM  BIOS, and  the  console  will  display
        squashed characters in 80-column mode.  However, programs which
        need  80-column  mode, which  may  have  crashed  before,  work
        correctly now.

        Because of bugs in the emulation, not all programs run properly
        (although the author does attempt to get all programs working).
        Those programs that are known to  fail under  Dapple have  been
        documented in the file "compat.txt".

        Some programs crash or hang mysteriously; see the compatibility
        list for details.

        To  report  a  bug, e-mail  the  maintainer, Steve Nickolas, at
        <steve@dosius.zzn.com>.   Please   read   the   FAQ   and   the
        compatibility list first.

See also
        The Dapple FAQ is contained in "dapple.txt".

Author
        The original Apple emulation code was written by Steve Nickolas
        <steve@dosius.zzn.com>, with some code  taken  from an emulator
        written by Andrew Gregory, and contributions from David Empson,
        Holger  Picker  and   others   on  <comp.emulators.apple2>  and
        <comp.sys.apple2>.  If  anyone's  name  has  been  omitted, the
        author apologizes; he is, after all, only human.
